"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class StudyEntry(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "format",
        "samplesData",
        "stats",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import opencb as opencb_1_3_1

        return {
            "files": opencb_1_3_1.FileEntry,
            "secondaryAlternates": opencb_1_3_1.AlternateCoordinate,
            "stats": opencb_1_3_1.VariantStats,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_13 import opencb as opencb_1_3_1

        return {
            "org.opencb.biodata.models.variant.avro.FileEntry": opencb_1_3_1.FileEntry,
            "org.opencb.biodata.models.variant.avro.AlternateCoordinate": opencb_1_3_1.AlternateCoordinate,
            "org.opencb.biodata.models.variant.avro.VariantStats": opencb_1_3_1.VariantStats,
            "org.opencb.biodata.models.variant.avro.StudyEntry": opencb_1_3_1.StudyEntry,
        }

    __slots__ = [
        "format",
        "samplesData",
        "stats",
        "files",
        "secondaryAlternates",
        "studyId",
    ]

    def __init__(
        self,
        format,
        samplesData,
        stats,
        files=list,
        secondaryAlternates=None,
        studyId=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_1.StudyEntry model.

        :param format:
            * Fields stored for each sample.
        :type format: list[str]
        :param samplesData:
            * Genotypes and other sample-related information. Each position is
            related          * with one sample. The content are lists
            of values in the same order than the          * format
            array. The length of this lists must be the same as the
            format field.
        :type samplesData: list[list[str]]
        :param stats:
            * Statistics of the genomic variation, such as its alleles/genotypes
            count          * or its minimum allele frequency, grouped
            by cohort name.
        :type stats: dict[str, VariantStats]
        :param files:
            * List of files from the study where the variant was present.
        :type files: list[FileEntry]
        :param secondaryAlternates:
            * Alternate alleles that appear along with a variant alternate.
        :type secondaryAlternates: None | list[AlternateCoordinate]
        :param studyId:
            * Unique identifier of the study.
        :type studyId: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.1"
